      subroutine Rearrange_FFT_Style(idim1, idim2, array_in, array_out) 

C     Rearrange "Fourier style" packed data (array_in) into normal style
C     image with center in the middle of the array (array_out).  This is
C     especially useful for CC style maps
C     
C     December 2003 MBS  PURDUE UNIVERSITY
C     Modified 10-Dec-2003 BY M. Sherman
C     Modified 22-aug-2006, R Sinkovits, cleanup and generalization to
C       properly handle odd values of IDIM1 and IDIM2

      implicit none

      integer*4, intent(in) :: idim1, idim2
      real*4, intent(in)    :: array_in (idim1, idim2)
      real*4, intent(out) :: array_out(-idim1/2+mod(idim1+1,2):idim1/2,
     $                                 -idim2/2+mod(idim2+1,2):idim2/2)

      integer*4 row, col
      integer*4 i, j, idim1d2, idim2d2

      idim1d2 = idim1/2
      idim2d2 = idim2/2

      do j = 1, idim2
         row = j
         if(row > idim2d2) row = j - idim2
         do i = 1, idim1
            col = i
            if(col > idim1d2) col = i - idim1
            array_out(col,row) = array_in(i,j)
         end do
      end do

      return
      end subroutine rearrange_fft_style
